diff -urN gcc-3.0.4-eelinux.orig/configure.in gcc-3.0.4-eelinux/configure.in
--- gcc-3.0.4-eelinux.orig/configure.in	Mon Aug 13 11:14:49 2001
+++ gcc-3.0.4-eelinux/configure.in	Thu Mar  7 03:47:25 2002
@@ -276,6 +276,7 @@
     alpha*-dec-osf*)	enable_shared=yes ;;
     alpha*-*-linux*)	enable_shared=yes ;;
     mips-sgi-irix5*)	enable_shared=yes ;;
+    mips*-*-linux*)	enable_shared=yes ;;
     *)			enable_shared=no ;;
   esac
 fi
diff -urN gcc-3.0.4-eelinux.orig/gcc/c-common.c gcc-3.0.4-eelinux/gcc/c-common.c
--- gcc-3.0.4-eelinux.orig/gcc/c-common.c	Thu Jan 31 18:31:52 2002
+++ gcc-3.0.4-eelinux/gcc/c-common.c	Thu Mar  7 03:47:25 2002
@@ -1842,10 +1842,8 @@
   if (mode == TYPE_MODE (intDI_type_node))
     return unsignedp ? unsigned_intDI_type_node : intDI_type_node;
 
-#if HOST_BITS_PER_WIDE_INT >= 64
   if (mode == TYPE_MODE (intTI_type_node))
     return unsignedp ? unsigned_intTI_type_node : intTI_type_node;
-#endif
 
   if (mode == TYPE_MODE (float_type_node))
     return float_type_node;
@@ -1896,10 +1894,8 @@
     return long_long_unsigned_type_node;
   if (type1 == widest_integer_literal_type_node)
     return widest_unsigned_literal_type_node;
-#if HOST_BITS_PER_WIDE_INT >= 64
   if (type1 == intTI_type_node)
     return unsigned_intTI_type_node;
-#endif
   if (type1 == intDI_type_node)
     return unsigned_intDI_type_node;
   if (type1 == intSI_type_node)
@@ -1931,10 +1927,8 @@
     return long_long_integer_type_node;
   if (type1 == widest_unsigned_literal_type_node)
     return widest_integer_literal_type_node;
-#if HOST_BITS_PER_WIDE_INT >= 64
   if (type1 == unsigned_intTI_type_node)
     return intTI_type_node;
-#endif
   if (type1 == unsigned_intDI_type_node)
     return intDI_type_node;
   if (type1 == unsigned_intSI_type_node)
@@ -2828,16 +2822,12 @@
   pushdecl (build_decl (TYPE_DECL, NULL_TREE, intHI_type_node));
   pushdecl (build_decl (TYPE_DECL, NULL_TREE, intSI_type_node));
   pushdecl (build_decl (TYPE_DECL, NULL_TREE, intDI_type_node));
-#if HOST_BITS_PER_WIDE_INT >= 64
   pushdecl (build_decl (TYPE_DECL, get_identifier ("__int128_t"), intTI_type_node));
-#endif
   pushdecl (build_decl (TYPE_DECL, NULL_TREE, unsigned_intQI_type_node));
   pushdecl (build_decl (TYPE_DECL, NULL_TREE, unsigned_intHI_type_node));
   pushdecl (build_decl (TYPE_DECL, NULL_TREE, unsigned_intSI_type_node));
   pushdecl (build_decl (TYPE_DECL, NULL_TREE, unsigned_intDI_type_node));
-#if HOST_BITS_PER_WIDE_INT >= 64
   pushdecl (build_decl (TYPE_DECL, get_identifier ("__uint128_t"), unsigned_intTI_type_node));
-#endif
 
   /* Create the widest literal types.  */
   widest_integer_literal_type_node
diff -urN gcc-3.0.4-eelinux.orig/gcc/config/mips/ee-perfcounter.c gcc-3.0.4-eelinux/gcc/config/mips/ee-perfcounter.c
--- gcc-3.0.4-eelinux.orig/gcc/config/mips/ee-perfcounter.c	Wed Dec 31 18:00:00 1969
+++ gcc-3.0.4-eelinux/gcc/config/mips/ee-perfcounter.c	Thu Mar  7 03:47:25 2002
@@ -0,0 +1,647 @@
+/* GCC rutime support routines for bb profiling with 
+   EE performance counter */
+
+/* Copyright (C) 2001  Sony Computer Entertainment Inc. 
+   Copyright 2001  Sony Corportaion.  */
+
+/* This file is derived from libgcc2.c and subject to the original 
+   license of libgcc2.c, as follows. */
+
+/* Compile this one with gcc.  */
+/* Copyright (C) 1989, 92-98, 1999 Free Software Foundation, Inc.
+
+This file is part of GNU CC.
+
+GNU CC is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+GNU CC is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU CC; see the file COPYING.  If not, write to
+the Free Software Foundation, 59 Temple Place - Suite 330,
+Boston, MA 02111-1307, USA.  */
+
+/* As a special exception, if you link this library with other files,
+   some of which are compiled with GCC, to produce an executable,
+   this library does not by itself cause the resulting executable
+   to be covered by the GNU General Public License.
+   This exception does not however invalidate any other reasons why
+   the executable file might be covered by the GNU General Public License.  */
+
+
+#include "tconfig.h"
+
+/* fixproto guarantees these system headers exist. */
+#include <stdlib.h>
+#include <unistd.h>
+
+#include "machmode.h"
+#include "defaults.h" 
+
+#include <stdio.h>
+#include <asm/sys_r5900.h>
+
+#ifndef BB_INITAL_STACK_SIZE
+#define BB_INITAL_STACK_SIZE	10
+#endif
+#ifndef BB_GROWTH_OF_STACK_SIZE 
+#define BB_GROWTH_OF_STACK_SIZE	100
+#endif
+
+/********
+ *
+ * Basic structures for bb profiling.
+ * These definition of structures must be sync with in "libgcc2.c".
+ *
+ */
+
+/* This sttucture is used the connection to the outside world.
+   The BLOCK_PROFILER macro must set __bb.blocks
+   and __bb.blockno.  */
+
+struct __bb {
+  unsigned long blockno;
+  struct bb *blocks;
+} ;
+
+struct bb_extension {
+	char flags;
+#if  defined(BB_CONSTRUCT_PRIVATE_RECORD) \
+  || defined(BB_DESTRUCT_PRIVATE_RECORD)  \
+  || defined(BB_PRINT_PRIVATE_RECORD) 
+	void *private;
+#endif
+};
+
+/* Structure emitted by -a  */
+/* must be sync with emitting LPBX0 part 
+		of end_final() in final.c */
+struct bb
+{
+  long zero_word;
+  const char *filename;
+  long *counts;
+  long ncounts;
+  struct bb *next;
+  const unsigned long *addresses;
+
+  /* Older GCC's did not emit these fields.  */
+  long nwords;
+  const char **functions;
+  const long *line_nums;
+  const char **filenames;
+  struct bb_extension *extension;
+};
+
+enum bb_func_mode
+{
+  TRACE_KEEP = 0, TRACE_ON = 1, TRACE_OFF = 2
+};
+
+/*
+ * End of basic structure definitons
+ *
+ ********/
+
+#ifdef HAVE_POPEN
+
+/*#include <sys/types.h>*/
+#include <sys/stat.h>
+/*#include <malloc.h>*/
+
+/* Commands executed by gopen.  */
+
+#define GOPENDECOMPRESS "gzip -cd "
+#define GOPENCOMPRESS "gzip -c >"
+
+/* Like fopen but pipes through gzip.  mode may only be "r" or "w".
+   If it does not compile, simply replace gopen by fopen and delete
+   '.gz' from any first parameter to gopen.  */
+
+static FILE *
+gopen (char *fn, char *mode)
+{
+  int use_gzip;
+  char *p;
+
+  if (mode[1])
+    return (FILE *) 0;
+
+  if (mode[0] != 'r' && mode[0] != 'w') 
+    return (FILE *) 0;
+
+  p = fn + strlen (fn)-1;
+  use_gzip = ((p[-1] == '.' && (p[0] == 'Z' || p[0] == 'z'))
+	      || (p[-2] == '.' && p[-1] == 'g' && p[0] == 'z'));
+
+  if (use_gzip)
+    {
+      if (mode[0]=='r')
+        {
+          FILE *f;
+          char *s = (char *) malloc (sizeof (char) * strlen (fn)
+				     + sizeof (GOPENDECOMPRESS));
+          strcpy (s, GOPENDECOMPRESS);
+          strcpy (s + (sizeof (GOPENDECOMPRESS)-1), fn);
+          f = popen (s, mode);
+          free (s);
+          return f;
+        }
+
+      else
+        {
+          FILE *f;
+          char *s = (char *) malloc (sizeof (char) * strlen (fn)
+				     + sizeof (GOPENCOMPRESS));
+          strcpy (s, GOPENCOMPRESS);
+          strcpy (s + (sizeof (GOPENCOMPRESS)-1), fn);
+          if (!(f = popen (s, mode)))
+            f = fopen (s, mode);
+          free (s);
+          return f;
+        }
+    }
+
+  else
+    return fopen (fn, mode);
+}
+
+static int
+gclose (FILE *f)
+{
+  struct stat buf;
+
+  if (f != 0)
+    {
+      if (!fstat (fileno (f), &buf) && S_ISFIFO (buf.st_mode))
+        return pclose (f);
+
+      return fclose (f);
+    }
+  return 0;
+}
+
+#endif /* HAVE_POPEN */
+
+
+/*
+ * private methods & vars.
+ *
+ *
+ */
+
+static short bb_enable_perfcounter=0;
+static short bb_enable_trace_perfcounter=0;
+static struct sys_r5900_ctrs bb_last_ctrs;
+static FILE *bb_perfcountfile = (FILE *) 0;
+static struct __bb  previous_bb = {0, 0};
+
+static struct __bb  *perf_bb_stack = (struct __bb *) 0;
+static int perf_bb_stacksize = 0;
+static const struct __bb dummy_bb={0,0};
+static long perf_bb_callcount = 0;
+
+static int target[2] = { CCR_TARGET_U, CCR_TARGET_U};
+static int event[2] = {CCR_CTR0_NO_EVENT,CCR_CTR1_NO_EVENT};
+
+struct event_table {
+	int val;
+	char *name;
+};
+
+static struct  event_table counter0_event_table[] = {
+	{CCR_CTR0_CPU_CYCLE           ,   "Processor_cycle"},
+	{CCR_CTR0_SINGLE_ISSUE        ,   "Single_instructions_issue"},
+	{CCR_CTR0_BRANCH_ISSUED       ,   "Branch_issued"},
+	{CCR_CTR0_BTAC_MISS           ,   "BTAC_miss"},
+	{CCR_CTR0_TLB_MISS            ,   "TLB_miss"},
+	{CCR_CTR0_ICACHE_MISS         ,   "Instruction_cache_miss"},
+	{CCR_CTR0_DTLB_ACCESSED       ,   "DTLB_accessed"},
+	{CCR_CTR0_NONBLOCK_LOAD       ,   "Non-blocking_load"},
+	{CCR_CTR0_WBB_SINGLE_REQ      ,   "WBB_single_request"},
+	{CCR_CTR0_WBB_BURST_REQ       ,   "WBB_burst_request"},
+	{CCR_CTR0_ADDR_BUS_BUSY       ,   "CPU_address_bus_busy"},
+	{CCR_CTR0_INST_COMP           ,   "Instruction_completed"},
+	{CCR_CTR0_NON_BDS_COMP        ,   "Non-BDS_instruction_completed"},
+	{CCR_CTR0_COP2_COMP           ,   "COP2_instruction_completed"},
+	{CCR_CTR0_LOAD_COMP           ,   "Load_completed"},
+	{CCR_CTR0_NO_EVENT            ,   "No_event"},
+	{0,0}};
+
+static struct  event_table counter1_event_table[]= {
+	{CCR_CTR1_LOW_BRANCH_ISSUED   ,   "Low-order_branch_issued"},
+	{CCR_CTR1_CPU_CYCLE           ,   "Processor_cycle"},
+	{CCR_CTR1_DUAL_ISSUE          ,   "Dual_instructions_issue"},
+	{CCR_CTR1_BRANCH_MISS_PREDICT ,   "Branch_miss-predicted"},
+	{CCR_CTR1_ITLB_MISS           ,   "ITLB_miss"},
+	{CCR_CTR1_DTLB_MISS           ,   "DTLB_miss"},
+	{CCR_CTR1_DCACHE_MISS         ,   "Data_cache_miss"},
+	{CCR_CTR1_WBB_SINGLE_UNAVAIL  ,   "WBB_single_request_unavailable"},
+	{CCR_CTR1_WBB_BURST_UNAVAIL   ,   "WBB_burst_request_unavailable"},
+	{CCR_CTR1_WBB_BURST_ALMOST    ,   "WBB_burst_request_almost_full"},
+	{CCR_CTR1_WBB_BURST_FULL      ,   "WBB_burst_request_full"},
+	{CCR_CTR1_DATA_BUS_BUSY       ,   "CPU_data_bus_busy"},
+	{CCR_CTR1_INST_COMP           ,   "Instruction_completed"},
+	{CCR_CTR1_NON_BDS_COMP        ,   "Non-BDS_instruction_completed"},
+	{CCR_CTR1_COP1_COMP           ,   "COP1_instruction_completed"},
+	{CCR_CTR1_STORE_COMP          ,   "Store_completed"},
+	{CCR_CTR1_NO_EVENT            ,   "No_event"},
+	{0,0}};
+
+static struct event_table * event_selector[] = {
+	counter0_event_table,
+	counter1_event_table
+};
+
+
+
+inline
+static
+int bb_performance_counter_parser(const char *p, int perfcounter)
+{
+	int i;
+
+	i =     strlen("target:");
+	if (!strncmp(p,"target:", i) ){
+		p += i;
+		i = 0;
+		--p;
+		do {
+			p ++;
+			switch (*p) {
+			  case 'U':
+				i |=  CCR_TARGET_U;
+				break;
+			  case 'S':
+				i |=  CCR_TARGET_S;
+				break;
+			  case 'K':
+				i |=  CCR_TARGET_K;
+				break;
+			  case 'E':
+				i |=  CCR_TARGET_EXL;
+				break;
+			  default:
+				return 0;
+			}
+			p ++;
+		}
+		while ( *p == '|' );
+		target[perfcounter] = i;
+		return 1;
+	}
+	else{
+		i =     strlen("event:");
+		if (!strncmp(p,"event:", i) ){
+			struct event_table *acceptable_event = 
+				event_selector[perfcounter];
+			p += i;
+			i = 0;
+			while ( acceptable_event[i].name ) {
+				if ( !strcmp(acceptable_event[i].name, p)) {
+					event[perfcounter] = 
+						acceptable_event[i].val;
+					return 1;
+				}
+				i ++;
+			}
+			return 0;
+		}
+	}
+}
+
+inline 
+static void bb_shutdown_ctrs(void)
+{
+	int ccr;
+	ccr=0;
+	sysmips(MIPS_SYS_R5900,SYS_R5900_SET_CCR, &ccr);
+}
+
+/*
+ * return 1 if busy or fail.
+ * oterwise return 0;
+ */
+inline 
+static int bb_init_ctrs(void)
+{
+	int ccr;
+	struct sys_r5900_ctrs zero_ctrs = {0,0};
+	if (sysmips(MIPS_SYS_R5900,SYS_R5900_GET_CCR, &ccr)){
+		return 1;
+	}
+	if (CCR_GET_CTE(ccr))
+		return 1;
+	ccr = 0;
+	if ( sysmips(MIPS_SYS_R5900,SYS_R5900_SET_CCR, &ccr))
+		return 1;;
+	if (sysmips(MIPS_SYS_R5900,SYS_R5900_SET_CTRS, &zero_ctrs))
+		return 1;;
+
+	ccr = CCR_SET_CTE(ccr, 1);
+	ccr = CCR_SET_CTR0_TARGET(ccr, target[0]);
+	ccr = CCR_SET_CTR1_TARGET(ccr, target[1]);
+	ccr = CCR_SET_CTR0_EVENT(ccr, event[0]);
+	ccr = CCR_SET_CTR1_EVENT(ccr, event[1]);
+
+	return (sysmips(MIPS_SYS_R5900,SYS_R5900_SET_CCR, &ccr));
+}
+
+inline
+static int bb_get_ctrs( struct sys_r5900_ctrs *p_val)  
+{
+	return sysmips(MIPS_SYS_R5900,SYS_R5900_GET_CTRS, p_val);
+}
+
+inline 
+static void bb_delta_ctrs( 
+	struct sys_r5900_ctrs *p_dst,  
+	struct sys_r5900_ctrs *p_new,  
+	struct sys_r5900_ctrs *p_old)  
+{
+	p_dst->ctr0 = p_new->ctr0 - p_old->ctr0;
+	p_dst->ctr1 = p_new->ctr1 - p_old->ctr1;
+	p_dst->ctr0 &=  ~( (__u64) 1 << 63 );
+	p_dst->ctr1 &=  ~( (__u64) 1 << 63 );
+}
+
+
+/* bb_record_perf_count() */
+/* 	update previous_bb's perfctrs record */
+/* 	update previous_bb as given *p__bb */
+/*	record current value of perfctrs into "bbperfcount.gz" */
+/*		if trace_flag is ON */
+
+#define BB_TRACE_ON	1
+#define BB_TRACE_OFF	0
+inline
+static
+void bb_record_perf_count(const struct __bb * p__bb, int trace_flag)
+{
+	struct sys_r5900_ctrs delta_ctrs, ctrs;
+
+	/* obatin current counters */
+	bb_get_ctrs(&ctrs);
+
+	/* calc. ctrs diff */
+	bb_delta_ctrs(&delta_ctrs, &ctrs, &bb_last_ctrs);
+
+	/* update last ctrs */
+	bb_last_ctrs = ctrs;
+ 
+	if (previous_bb.blocks) {
+		register struct sys_r5900_ctrs * p_ctrs;
+		p_ctrs = previous_bb.blocks->
+				extension[previous_bb.blockno].private;
+		p_ctrs ->ctr0 += delta_ctrs.ctr0;
+		p_ctrs ->ctr1 += delta_ctrs.ctr1;
+	}
+	previous_bb = *p__bb;
+	if (!bb_perfcountfile) return;
+
+	if ( trace_flag == BB_TRACE_ON) {
+		/* write current ctrs */
+		fwrite (&ctrs, sizeof (ctrs), 1, bb_perfcountfile);
+	}
+}
+
+/*
+ * exported methods
+ *
+ *
+ */
+
+/*
+ * constructor/destructor of private record
+ */
+int __bb_alloc_r5900_perf_counter(void **p_private)
+{
+	*p_private = calloc(1, sizeof(struct sys_r5900_ctrs));
+	return ( *p_private != 0);
+};
+
+void __bb_free_r5900_perf_counter(void **p_private)
+{
+	if (*p_private) { 
+		free(*p_private); 
+		*p_private = 0;
+	}
+};
+
+
+/*
+ * reporter of private record
+ */
+void __bb_print_r5900_perf_counter(FILE *file, void *private)
+{
+	struct sys_r5900_ctrs *p_ctrs  = private;
+	if (bb_enable_perfcounter) {
+		fprintf(file," counter#0(0x%01x:0x%02x):0x%016llx", 
+			target[0],event[0], p_ctrs->ctr0);
+		fprintf(file," counter#1(0x%01x:0x%02x):0x%016llx", 
+			target[1],event[1], p_ctrs->ctr1);
+	}
+}
+
+/*
+ * parser of bb.in 
+ */
+int __bb_parse_r5900_perf_counter(const char *p)
+{
+	int i;
+	if (!strcmp(p,"enable_trace_performance_counter") ){
+		bb_enable_trace_perfcounter = 1;
+		return 1;
+	};
+	if (!strcmp(p,"enable_performance_counter") ){
+		bb_enable_perfcounter = 1;
+		return 1;
+	};
+
+	i =     strlen("performance_counter#");
+	if (!strncmp(p,"performance_counter#", i) ){
+		int perfcounter;
+		p += i;
+		perfcounter = *p -'0';
+		if (perfcounter != 0 && perfcounter != 1 ) {
+			return 0;
+		}
+		p ++;
+		if (*p != ':' ) return 0;
+		p ++;
+		
+		return bb_performance_counter_parser(p, perfcounter);
+
+	}
+	return 0;
+}
+
+/*
+ * called once per program.
+ */
+
+void __bb_init_r5900_perf_counter()
+{
+	if (bb_enable_perfcounter) {
+		perf_bb_stacksize = BB_INITAL_STACK_SIZE;
+		perf_bb_stack = (struct __bb *) malloc 
+				(perf_bb_stacksize * sizeof (struct __bb));
+		if (!perf_bb_stack)
+			perf_bb_stacksize = 0;
+
+		if (bb_init_ctrs()) {
+			/* fail or busy */
+			bb_enable_perfcounter=0;
+			bb_enable_trace_perfcounter=0;
+			return ;
+		};
+		bb_get_ctrs(&bb_last_ctrs);
+	}
+	if (bb_enable_trace_perfcounter) {
+		bb_enable_perfcounter = 1;
+#ifdef HAVE_POPEN 
+		bb_perfcountfile = gopen ("bbperfcount.gz", "w");
+#else
+		bb_perfcountfile = fopen ("bbperfcount", "w");
+#endif
+	}
+}
+
+void __bb_exit_r5900_perf_counter()
+{
+	if ( bb_enable_perfcounter ) {
+		/* record final. portion */
+		bb_record_perf_count(&dummy_bb,BB_TRACE_ON);
+		/* shutdown counter */
+		bb_shutdown_ctrs();
+	}
+	if (bb_perfcountfile) {
+#ifdef HAVE_POPEN
+		gclose (bb_perfcountfile);
+#else
+		fclose (bb_perfcountfile);
+#endif /* HAVE_POPEN */
+	}
+	if (perf_bb_stack) {
+		free (perf_bb_stack);
+		perf_bb_stack = 0;
+	}
+}
+
+
+/*
+ * called on every entering to BB.
+ */
+void __bb_trace_r5900_perf_counter(struct __bb *p__bb)
+{
+	if ( bb_enable_perfcounter ) {
+		bb_record_perf_count(p__bb, BB_TRACE_ON);
+	}
+}
+
+
+/*
+ * called on every entering to function.
+ */
+void __bb_init_trace_r5900_perf_counter
+	(struct bb *blocks, unsigned long blockno)
+{
+	static short reported = 0;
+
+	/* return if perfcounting is not enabled */
+	if ( !bb_enable_perfcounter ) {
+		return;
+	}
+
+	/* update last ovserved counter value and then return, 
+		if cannot operate previous_bb's stack.*/
+	if (perf_bb_stacksize == 0) {
+		bb_record_perf_count(&dummy_bb,BB_TRACE_OFF);
+		return;
+	}
+
+
+	if (perf_bb_callcount) {
+
+		perf_bb_callcount ++;
+
+		/* grow stack, if needed */
+		if (perf_bb_callcount >= perf_bb_stacksize) {
+			int newsize = perf_bb_callcount + 
+					BB_GROWTH_OF_STACK_SIZE;
+			perf_bb_stack = (struct __bb *) 
+				realloc (perf_bb_stack, 
+				newsize*sizeof(struct __bb));
+			if (! perf_bb_stack) {
+				if (!reported) {
+					fprintf (stderr, 
+					   "Profiler: out of memory\n");
+					reported = 1;
+				}
+				perf_bb_stacksize = 0;
+				goto stack_overflow;
+			}
+			perf_bb_stacksize = newsize;
+		}
+
+		/* push previous_bb */
+		perf_bb_stack[perf_bb_callcount] = previous_bb;
+		/* recored perfcounters in previous_bb,
+			counted before entering the function */
+		bb_record_perf_count(&dummy_bb,BB_TRACE_OFF);
+stack_overflow:
+		return;
+	}
+
+	if (blocks->extension && 
+	      (blocks->extension[blockno].flags & TRACE_ON)) {
+
+		perf_bb_callcount = 1;
+		previous_bb=dummy_bb;
+		if (perf_bb_stack)
+			perf_bb_stack[perf_bb_callcount] = previous_bb;
+
+		/* update last ovserved counter value */
+		bb_record_perf_count(&dummy_bb,BB_TRACE_OFF);
+	} 
+}
+
+/*
+ * called on every leaving from function.
+ */
+
+void __bb_ret_trace_r5900_perf_counter(void)
+{
+	if ( !bb_enable_perfcounter ) {
+		return;
+	}
+
+	if (perf_bb_callcount) {
+		if ( perf_bb_stacksize > perf_bb_callcount) {
+		/* record counters in the last part of the function 
+			and pop previous_bb, if possible */
+			bb_record_perf_count (
+				&(perf_bb_stack[perf_bb_callcount]),
+				BB_TRACE_OFF);
+		}
+		else {
+	 		/* update last observed counters,  */
+			/* if stack is overflowed. */
+			bb_record_perf_count(&dummy_bb,BB_TRACE_OFF);
+		}
+		perf_bb_callcount --;
+	}
+}
+
+void __r5900_update_ctrs(void)
+{
+	bb_get_ctrs(&bb_last_ctrs);
+}
+
+
diff -urN gcc-3.0.4-eelinux.orig/gcc/config/mips/eelinux.h gcc-3.0.4-eelinux/gcc/config/mips/eelinux.h
--- gcc-3.0.4-eelinux.orig/gcc/config/mips/eelinux.h	Wed Dec 31 18:00:00 1969
+++ gcc-3.0.4-eelinux/gcc/config/mips/eelinux.h	Thu Mar  7 03:47:25 2002
@@ -0,0 +1,251 @@
+/*
+ *
+ *
+ *
+ */
+
+/* Experimental: */
+#define MIPS_ABI_DEFAULT ABI_32
+#undef mips_abi
+extern int mips_abi;
+/* End of experimental */
+
+#define MIPS_CPU_STRING_DEFAULT "R5900"
+
+#undef  MIPS_ISA_DEFAULT
+#define MIPS_ISA_DEFAULT 2
+
+#include "linux.h"
+#include "abi64.h"
+
+/*
+ * Override TARGET_DEFAULT
+ * for r5900 : default is -msingle-float
+ */
+#undef TARGET_DEFAULT
+#define TARGET_DEFAULT (MASK_ABICALLS|MASK_GAS|MASK_SINGLE_FLOAT|MASK_MIPS5900)
+
+#undef MACHINE_TYPE
+#define MACHINE_TYPE "(MIPSEL EE Linux/ELF)"
+
+/* How to output a quadword for the r5900.  */
+#define ASM_OUTPUT_QUADRUPLE_INT(STREAM,VALUE)                          \
+do {                                                                    \
+  if (TARGET_64BIT)                                                     \
+    {                                                                   \
+      fprintf (STREAM, "\t.octa\t");                                    \
+      if (HOST_BITS_PER_WIDE_INT < 64 || GET_CODE (VALUE) != CONST_INT) \
+        /* We can't use 'X' for negative numbers, because then we won't \
+           get the right value for the upper 32 bits.  */               \
+        output_addr_const (STREAM, VALUE);                              \
+      else                                                              \
+        /* We must use 'X', because otherwise LONG_MIN will print as    \
+           a number that the Irix 6 assembler won't accept.  */         \
+        print_operand (STREAM, VALUE, 'X');                             \
+      fprintf (STREAM, "\n");                                           \
+    }                                                                   \
+  else                                                                  \
+    {                                                                   \
+      assemble_integer (operand_subword ((VALUE), 0, 0, TImode),        \
+                        UNITS_PER_WORD, 1);                             \
+      assemble_integer (operand_subword ((VALUE), 1, 0, TImode),        \
+                        UNITS_PER_WORD, 1);                             \
+    }                                                                   \
+} while (0)
+
+/* ALIGN 128 bit objects */
+
+#define DEFAULT_MIPS_ALIGNMENT 128
+
+#undef SUBTARGET_TARGET_OPTIONS
+#define SUBTARGET_TARGET_OPTIONS					\
+  { "align128", &mips_align128_string,					\
+      "Speciy 128bit alignment to use"},				\
+  { "no-align128", &mips_no_align128_string,				\
+      "Speciy no 128bit alignment to use"},				\
+  { "abi=", &mips_abi_string,						\
+      "Speciy ABI to use"},
+
+#undef STACK_BOUNDARY
+#define STACK_BOUNDARY							\
+  ((mips_abi == ABI_32 || mips_abi == ABI_O64 || mips_abi == ABI_EABI)	\
+   ? 64 : 128)
+
+#undef MIPS_STACK_ALIGN
+#define MIPS_STACK_ALIGN(LOC)						\
+  (((mips_abi == ABI_32 || mips_abi == ABI_O64 || mips_abi == ABI_EABI)	\
+    && mips_alignment != 128 )	 					\
+   ? ((LOC) + 7) & ~7							\
+   : ((LOC) + 15) & ~15)
+
+
+#undef  BIGGEST_ALIGNMENT 
+#define BIGGEST_ALIGNMENT  mips_alignment
+
+#define PREFERRED_STACK_BOUNDARY \
+(mips_alignment == 128 ? 128 : 						\
+  ((mips_abi == ABI_32 || mips_abi == ABI_O64 || mips_abi == ABI_EABI )	\
+   ? 64 : 128))
+
+
+/*
+
+	    ** Table of cc1 flags v.s. stack alignment related values **
+
+	STACK_BOUNDARY MIPS_STACK_ALIGN BIGGEST_ALIGNMENT  PREFERRED_STACK_BOUNDARY
+o32/o64		64		64		64		64
+ +align128	64		128		128		128
+n32/n64		128		128		64		128
+ +align128	128		128		128		128
+*/
+
+/*
+////////////
+//
+// default mips2 
+//
+// default is  elf, -mabi=o32, -mips2, -mcpu=r5900  and -EL
+*/
+#undef CPP_PREDEFINES
+#define CPP_PREDEFINES "\
+-D__ELF__ -D_MIPS_SIM=_MIPS_SIM_ABI32 \
+-D_MIPS_ISA=_MIPS_ISA_MIPS2 \
+-Dunix  -D__unix__ \
+-Dlinux -D__linux__ \
+-Dmips -D_mips -D__mips -D__mips__ \
+-DR3000 -D_R3000 \
+-DMIPSEL -D_MIPSEL -D__MIPSEL -D__MIPSEL__ \
+-Asystem(linux) -Asystem(posix) -Acpu(mips) -Amachine(mips) \
+ "
+
+#undef SUBTARGET_CPP_SPEC 
+#define SUBTARGET_CPP_SPEC "\
+%{mfp32: -D_MIPS_FPSET=16}%{!mfp32: -D_MIPS_FPSET=32} \
+%{mips1: -U_MIPS_ISA -D_MIPS_ISA=_MIPS_ISA_MIPS1} \
+%{mips2: -U_MIPS_ISA -D_MIPS_ISA=_MIPS_ISA_MIPS2} \
+%{mips3: -U_MIPS_ISA -D_MIPS_ISA=_MIPS_ISA_MIPS3 -UR3000 -U_R3000} \
+%{mips4: -U_MIPS_ISA -D_MIPS_ISA=_MIPS_ISA_MIPS4 -UR3000 -U_R3000} \
+%{!mips*: -D_MIPS_ISA=_MIPS_ISA_MIPS2} \
+%{fno-PIC: -U__PIC__ -U__pic__} \
+%{fno-pic: -U__PIC__ -U__pic__} \
+%{fPIC: -D__PIC__ -D__pic__} \
+%{fpic: -D__PIC__ -D__pic__} \
+%{!fpic: %{!fPIC: %{!fno-pic: %{!fno-pic: -D__PIC__ -D__pic__}}}} \
+%{-D__HAVE_FPU__ } \
+%{posix: -D_POSIX_SOURCE} \
+%{.cc:	-D__LANGUAGE_C_PLUS_PLUS__  %{!ansi:-DLANGUAGE_C_PLUS_PLUS}} \
+%{.cxx:	-D__LANGUAGE_C_PLUS_PLUS__  %{!ansi:-DLANGUAGE_C_PLUS_PLUS}} \
+%{.C:	-D__LANGUAGE_C_PLUS_PLUS__  %{!ansi:-DLANGUAGE_C_PLUS_PLUS}} \
+%{.m:	-D__LANGUAGE_OBJECTIVE_C__ %{!ansi:-DLANGUAGE_OBJECTIVE_C}} \
+%{.S:	-D__LANGUAGE_ASSEMBLY__ %{!ansi:-DLANGUAGE_ASSEMBLY}} \
+%{.s:	-D__LANGUAGE_ASSEMBLY__ %{!ansi:-DLANGUAGE_ASSEMBLY}} \
+%{!.S: %{!.s: %{!.cc: %{!.cxx: %{!.C: %{!.m: -D__LANGUAGE_C__ %{!ansi:-DLANGUAGE_C}}}}}} } \
+%{ansi:-Uunix -Ulinux -Umips -UR3000 -UMIPSEB -UMIPSEL} \
+%{ffast-math: -D__FAST_MATH__} \
+%{!mcpu*: -D__R5900 -D_R5900} \
+%{mcpu=r5900: -D__R5900 -D_R5900} \
+ "
+#undef SUBTARGET_CC1_SPEC
+#define SUBTARGET_CC1_SPEC "\
+%{fno-pic: -mno-abicalls} \
+ "
+
+#undef SUBTARGET_ASM_SPEC
+#define SUBTARGET_ASM_SPEC "\
+%{!mcpu*:  -mwarn-short-loop} \
+%{!mcpu*:  -mcpu=r5900} \
+%{fno-pic: -non_shared} \
+%{mno-abicalls: -non_shared} \
+%{!fno-pic: %{!mno-abicalls: -KPIC}} \
+%{!mips*: -mips2} \
+%{!mdouble-float: -msingle-float} \
+ "
+
+
+/* 
+ * Default fucntion and data alignment values for r5900 
+ */
+
+/* prefer .p2align rather than .align (gas assumed) */
+#define ASM_OUTPUT_MAX_SKIP_ALIGN(FILE,LOG,MAX_SKIP) \
+  if ((LOG)!=0) \
+    if ((MAX_SKIP)==0) fprintf ((FILE), "\t.p2align %d\n", (LOG)); \
+    else fprintf ((FILE), "\t.p2align %d,,%d\n", (LOG), (MAX_SKIP))
+
+#undef DEFAULT_LOOP_ALIGN
+#undef DEFAULT_LOOP_MAX_SKIP
+#undef DEFAULT_JUMP_ALIGN
+#undef DEFAULT_JUMP_MAX_SKIP
+#undef DEFAULT_FUNCTION_ALIGN
+#undef DEFAULT_FUNCTION_MAX_SKIP
+
+#define DEFAULT_LOOP_ALIGN 3
+#define DEFAULT_LOOP_MAX_SKIP 0
+#define DEFAULT_JUMP_ALIGN 2
+#define DEFAULT_JUMP_MAX_SKIP 0
+#define DEFAULT_FUNCTION_ALIGN 3
+#define DEFAULT_FUNCTION_MAX_SKIP 0
+
+/*
+ * bb profiling extension
+ *
+ *construct/destruct private reocord in strunc bb
+ * int  BB_CONSTRUCT_PRIVATE_RECORD(void **p_private)
+ *	( return 1 if successed, otherwise return 0 )
+ * void BB_DESTRUCT_PRIVATE_RECORD(void **p_private)
+ *
+ *called from "bb.out" reporter
+ * void BB_PRINT_PRIVATE_RECORD(FILE*, void *private)
+ *
+ *called from "bb.in" parser
+ * int  BB_PARSE_PRIVATE(char *bb_in)	
+ *	( return 1 if processed, otherwise return 0 )
+ *
+ *called per once program
+ * void BB_INIT_PRIVATE(void)
+ * void BB_EXIT_PRIVATE(void)
+ *
+ *called when etering/returning function
+ * void BB_INIT_TRACE_FUNC_PRIVATE(struct bb *blocks, unsigned long blockno)
+ * void BB_TRACE_RET_PRIVATE(void)
+ *
+ *called when entering bb
+ * void BB_TRACE_FUNC_PRIVATE(struct __bb * p__bb)
+ *
+ */
+
+#define BB_CONSTRUCT_PRIVATE_RECORD(p_private)	\
+		__bb_alloc_r5900_perf_counter(p_private)
+
+#define BB_DESTRUCT_PRIVATE_RECORD(p_private)	\
+		__bb_free_r5900_perf_counter(p_private)
+
+#define BB_PRINT_PRIVATE_RECORD(file,private)	\
+		__bb_print_r5900_perf_counter(file,private)
+
+#define BB_PARSE_PRIVATE(ptr)	\
+		__bb_parse_r5900_perf_counter(ptr)
+
+#define BB_INIT_PRIVATE		\
+		__bb_init_r5900_perf_counter
+
+#define BB_EXIT_PRIVATE		\
+		__bb_exit_r5900_perf_counter
+
+#define BB_TRACE_FUNC_PRIVATE(pbb)	\
+		__bb_trace_r5900_perf_counter(pbb)
+
+#define BB_INIT_TRACE_FUNC_PRIVATE(blocks, blockno) \
+		__bb_init_trace_r5900_perf_counter(blocks, blockno)
+
+#define BB_TRACE_RET_PRIVATE \
+		__bb_ret_trace_r5900_perf_counter
+
+/*
+ * bb_stack size
+ *	inital and growth value
+ *
+ */
+#define BB_INITAL_STACK_SIZE	100
+#define BB_GROWTH_OF_STACK_SIZE	100
+
